﻿unit Unit1;

interface

uses
  Winapi.Windows, AdvUtil, Data.DB, Data.Win.ADODB, Vcl.StdCtrls, Vcl.Graphics, System.Classes, Vcl.Controls, Vcl.Grids, AdvObj, BaseGrid, AdvGrid,
  DBAdvGrid, Vcl.Forms, widestrutils, SysUtils, Vcl.ExtCtrls, AdvOfficePager, AdvOfficePagerStylers,AdvOfficeButtons, AdvGlowButton, Vcl.Dialogs, asgprev;

type
  TForm1 = class(tForm)
    ADOQuery1: TADOQuery;
    DataSource1: TDataSource;
    Connection: TADOConnection;
    ADOQuery1PRODUCTNR: TStringField;
    ADOQuery1VOLGNR: TAutoIncField;
    ADOQuery1PRODUCTNAAM: TStringField;
    ADOQuery1ZOEKCODE: TStringField;
    ADOQuery1PRODUCTNAAMEIGEN: TStringField;
    ADOQuery1VERPAKKING: TStringField;
    ADOQuery1VERPAKKINGLEV: TStringField;
    ADOQuery1VERPAKKINGVERKPRIJS: TStringField;
    ADOQuery1EENHEIDSFACTOR: TFloatField;
    ADOQuery1EENHEID: TStringField;
    ADOQuery1VERKOOPPRIJS: TBCDField;
    ADOQuery1INKOOPPRIJS: TBCDField;
    ADOQuery1BRUTOPRIJSLEV: TBCDField;
    ADOQuery1BTWNR: TSmallintField;
    ADOQuery1OMZETGROOTBOEKNR: TIntegerField;
    ADOQuery1VOORRAADGROOTBOEKNR: TIntegerField;
    ADOQuery1KORTINGINKOOP: TFloatField;
    ADOQuery1VERKOOPINCL: TBooleanField;
    ADOQuery1LEVERANCIERNR: TIntegerField;
    ADOQuery1BESTELNR: TStringField;
    ADOQuery1GROEPNR: TStringField;
    ADOQuery1WINSTMARGE: TFloatField;
    ADOQuery1NETTOARTIKEL: TBooleanField;
    ADOQuery1GEVARENCODE: TStringField;
    ADOQuery1REGISNR: TStringField;
    ADOQuery1NOTITIES: TMemoField;
    ADOQuery1LAATSTEPRIJSWIJZ: TDateTimeField;
    ADOQuery1MINIMUMVOORRAAD: TFloatField;
    ADOQuery1MAXIMUMVOORRAAD: TFloatField;
    ADOQuery1BESTELHOEV: TFloatField;
    ADOQuery1VOORRAAD: TFloatField;
    ADOQuery1KWARTVOORRAAD1: TFloatField;
    ADOQuery1KWARTVOORRAAD2: TFloatField;
    ADOQuery1KWARTVOORRAAD3: TFloatField;
    ADOQuery1KWARTVOORRAAD4: TFloatField;
    ADOQuery1KWARTPRIJS1: TBCDField;
    ADOQuery1KWARTPRIJS2: TBCDField;
    ADOQuery1KWARTPRIJS3: TBCDField;
    ADOQuery1KWARTPRIJS4: TBCDField;
    ADOQuery1BETREFT: TIntegerField;
    ADOQuery1VERWIJDERD: TBooleanField;
    ADOQuery1LAATSTEWIJZIGING: TDateTimeField;
    ADOQuery1BARCODE: TStringField;
    ADOQuery1KLEUR: TBooleanField;
    ADOQuery1MINEENH: TFloatField;
    ADOQuery1BESTELDAT: TDateTimeField;
    ADOQuery1LEVERDAT: TDateTimeField;
    ADOQuery1KLEURCODE: TStringField;
    ADOQuery1AANTALBESTELD: TFloatField;
    ADOQuery1LOCATIE: TStringField;
    ADOQuery1PRINTNOTKASSA: TBooleanField;
    ADOQuery1BESTELD: TFloatField;
    DBAdvGrid1: TDBAdvGrid;
    Panel1: TPanel;
    pKnoppen: TPanel;
    bbHerstel: TAdvGlowButton;
    pInstellen: TPanel;
    eHeadername: TEdit;
    bSaveHeader: TButton;
    lKolNaam: TLabel;
    lVinkje: TLabel;
    bSave: TButton;
    bRestore: TButton;
    cbFilter: TAdvOfficeCheckBox;
    eFilter: TEdit;
    AdvGlowButton1: TAdvGlowButton;
    bPrint: TButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    AdvPreviewDialog1: TAdvPreviewDialog;
    btSluiten: TAdvGlowButton;
    procedure FormActivate(Sender: TObject);
    procedure bSaveClick(Sender: TObject);
    procedure bRestoreClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBAdvGrid1FixedCellClick(Sender: TObject; ACol, ARow: Integer);
    procedure DBAdvGrid1GetCellColor(Sender: TObject; ARow, ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure cbFilterClick(Sender: TObject);
    procedure bSaveHeaderClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure AdvGlowButton1Click(Sender: TObject);
    procedure eFilterKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure bPrintClick(Sender: TObject);
  private
    s, sort, sort1: string;
    SortDown: boolean;
    Kiesveld: boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.AdvGlowButton1Click(Sender: TObject);
begin
  pInstellen.Visible := not pInstellen.Visible;
end;

procedure TForm1.bPrintClick(Sender: TObject);
var
  r:TRect;
  quarterpage:TRect;
begin
//  printersetupdialog1.Execute;
(*  with Printer do
  begin
    BeginDoc;
    r := Canvas.ClipRect;
    quarterpage:=rect(0,0,(r.right-r.left) shr 1,(r.bottom-r.top) shr 1);

    setmapmode(canvas.handle,mm_lometric);
    dptolp(canvas.handle,r,2);

    DBAdvGrid1.PrintSettings.FitToPage:=fpShrink;
    DBAdvGrid1.PrintDraw(canvas,quarterpage);

    DBAdvGrid1.PrintSettings.HeaderSize:=(-r.bottom) shr 1;
    DBAdvGrid1.PrintSettings.FitToPage:=fpShrink;
    DBAdvGrid1.PrintDraw(canvas,quarterpage);

    DBAdvGrid1.PrintSettings.LeftSize:=r.right shr 1;
    DBAdvGrid1.PrintSettings.FitToPage:=fpShrink;
    DBAdvGrid1.PrintDraw(canvas,quarterpage);

    DBAdvGrid1.PrintSettings.LeftSize:=r.right shr 1;
    DBAdvGrid1.PrintSettings.HeaderSize:=(-r.bottom) shr 1;
    DBAdvGrid1.PrintSettings.FitToPage:=fpShrink;
    DBAdvGrid1.PrintDraw(canvas,quarterpage);
    EndDoc;
  end;*)

//  with DBAdvGrid1.printsettings do
//  begin
//    Fixedheight := Strtoint(edit2.text) * 10;
//    Leftsize := Strtoint(edit3.text) * 10;
//    Headersize := Strtoint(edit4.text) * 10;
//    if Checkbox1.Checked then
//      Borders := pbSingle
//    else
//      Borders := pbNoborder;
//  end;
  DBAdvGrid1.SelectAll;
  AdvPreviewDialog1.Grid := DBAdvGrid1;
  AdvPreviewDialog1.Grid.GridLineColor:=clwhite;
//  AdvPreviewDialog1.Grid.SaveToXLS('Grid.xls');
  AdvPreviewDialog1.Execute;
end;

procedure TForm1.bRestoreClick(Sender: TObject);
begin
  if Kiesveld then
    DBAdvGrid1.Columns[1].Destroy;
  Kiesveld := false;
end;

procedure TForm1.bSaveHeaderClick(Sender: TObject);
begin
  DBAdvGrid1.Columns[DBAdvGrid1.SortSettings.Column].Header := eHeadername.Text;
end;

procedure TForm1.cbFilterClick(Sender: TObject);
begin
  if cbFilter.Checked then
  begin
    if DBAdvGrid1.Filter.Count > 0 then
      DBAdvGrid1.Filter[0].condition := (eFilter.text)
    else
      with DBAdvGrid1.Filter.Add do
      begin
        condition := (eFilter.text);
        data := fcRow;
      end;
  end;
  DBAdvGrid1.FilterActive := cbFilter.Checked;
end;

procedure TForm1.DBAdvGrid1FixedCellClick(Sender: TObject; ACol, ARow: Integer);
var
  p: tpoint;
begin
  if acol > 0 then
  begin
    DBAdvGrid1.SearchFooter.SearchColumn := acol;
    if DBAdvGrid1.Columns[acol].Header = '' then
      eHeadername.Text := DBAdvGrid1.Columns[acol].FieldName
    else
      eHeadername.Text := DBAdvGrid1.Columns[acol].Header;
    DBAdvGrid1.SearchFooter.SearchActiveColumnOnly := true;
    DBAdvGrid1.UpdateSearchPanel;
  end
  else
  begin
    DBAdvGrid1.SearchFooter.SearchColumn := -1;
    DBAdvGrid1.SearchFooter.SearchActiveColumnOnly := false;
    DBAdvGrid1.UpdateSearchPanel;
  end;
  p.X := 1;
  p.Y := 1;
  DBAdvGrid1.Find(p, DBAdvGrid1.SearchPanel.EditControl.Text, [fnAutoGoto]);
  // s := DBAdvGrid1.SearchPanel.EditControl.Text;
  // DBAdvGrid1.SearchPanel.EditControl.Text := s;
  // DBAdvGrid1.SearchPanel.ForwardButton.Click;
end;

procedure TForm1.DBAdvGrid1GetCellColor(Sender: TObject; ARow, ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin
//  if acol = DBAdvGrid1.SearchFooter.SearchColumn then
//    ABrush.Color := $00FEF8BA;
end;

procedure TForm1.eFilterKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if key = 13 then
    cbFilter.Checked := true;
  if key = 27 then
    cbFilter.Checked := false;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  f: textfile;
  sl: tstringlist;
  i: integer;
  Col: TDBGridColumnItem;
begin
  ADOQuery1.Open;
  AssignFile(f, 'Col.txt');
  Reset(f);
  Readln(f, s);
  DBAdvGrid1.StringToColumnStates(s);
  CloseFile(f);
  sl := tstringlist.Create;
  AssignFile(f, 'ColHeaders.txt');
  Reset(f);
  while not eof(f) do
  begin
    readln(f, s);
    sl.Add(s);
  end;
  CloseFile(f);
  if sl.Count = DBAdvGrid1.Columns.Count then
    for I := 0 to sl.Count - 1 do
      if sl[i] > '' then
        DBAdvGrid1.Columns[i].Header := sl[i];

        Kiesveld := false;
exit;
  Kiesveld := true;
  Sortdown := false;
  Col := DBAdvGrid1.Columns.Insert(1);
  Col.Editor := edDataCheckBox;
  Col.Header := 'Kies';
  Col.Alignment := taCenter;
  Col.Width := 40;

end;

procedure TForm1.bSaveClick(Sender: TObject);
var
  Col: TDBGridColumnItem;
begin
  if not Kiesveld then
  begin
    Col := DBAdvGrid1.Columns.Insert(1);
    Col.Editor := edDataCheckBox;
    Col.Header := 'Kies';
    Col.Alignment := taCenter;
    Col.Width := 40;
  end;
  Kiesveld := true;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  f: textfile;
  i: integer;
begin
  AssignFile(f, 'Col.txt');
  rewrite(f);
  writeln(f, DBAdvGrid1.ColumnStatesToString);
  CloseFile(f);
  AssignFile(f, 'ColHeaders.txt');
  rewrite(f);
  if Kiesveld then
    DBAdvGrid1.Columns[1].Destroy;
  for I := 0 to DBAdvGrid1.Columns.Count - 1 do
    writeln(f, DBAdvGrid1.Columns[i].Header);
  CloseFile(f);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DBAdvGrid1.Color := $00FEF3EB;
  DBAdvGrid1.ActiveRowShow := False;
  DBAdvGrid1.SelectionColor := clMoneyGreen;
  DBAdvGrid1.SelectionColorTo := $00FEF3EB; // clMoneyGreen;
  DBAdvGrid1.SelectionColorMixer := true;
  DBAdvGrid1.SelectionColorMixerFactor := 40;
  DBAdvGrid1.ShowSelection := true;
  DBAdvGrid1.ControlLook.CheckAlwaysActive := true;
  DBAdvGrid1.ControlLook.RadioAlwaysActive := true;
  DBAdvGrid1.ControlLook.FixedGradientFrom := clWhite;
  DBAdvGrid1.ControlLook.FixedGradientTo := $00FEF3EB;
  DBAdvGrid1.MouseActions.WheelIncrement := 1;
  DBAdvGrid1.Font.Charset := DEFAULT_CHARSET;
  DBAdvGrid1.Font.Color := clBlack;
  DBAdvGrid1.FixedFont := DBAdvGrid1.Font;
  DBAdvGrid1.FixedFont.Charset := DEFAULT_CHARSET;
  DBAdvGrid1.FixedFont.Color := clBlack;
  // DBAdvGrid1.Font.name := FontType;
  // DBAdvGrid1.DefaultRowHeight := 19 * Screen.PixelsPerInch div ScreenPPI;
  DBAdvGrid1.SortSettings.IgnoreBlanks := true;
  DBAdvGrid1.SortSettings.IgnoreCase := true;
  DBAdvGrid1.HoverRowColor := $00FFFAF2; // $00FEF8F3;//$00FEF4ED;//$00FCE8D8;
  DBAdvGrid1.HoverRowColorTo := $00FFFAF2; // $00FEF4EB;//$00FEF8F3;//$00F7BF93;
  DBAdvGrid1.ActiveCellColor := $00FCE8D8;
  DBAdvGrid1.ActiveCellColorTo := $00FCE8D8;
  DBAdvGrid1.SelectionColor := $00FCE8D8;
  DBAdvGrid1.SelectionColorTo := $00FCE8D8;
  DBAdvGrid1.HoverRow := true;
  sort := '';
  sort1 := '';
  Sortdown := false;
end;

end.
